<?php

namespace app\admin\controller;

use app\common\controller\Backend;
use app\common\model\Progress as ProgressModel;
use fast\Tree;
use think\Db;

/**
 * 分类管理
 *
 * @icon   fa fa-list
 * @remark 用于管理网站的所有分类,分类可进行无限级分类,分类类型请在常规管理->系统配置->字典配置中添加
 */
class Progress extends Backend
{

    /**
     * @var \app\common\model\Progress
     */
    protected $model = null;
    protected $Progresslist = [];
    protected $noNeedRight = ['selectpage'];

    // public function _initialize()
    // {
        // parent::_initialize();
        // $this->model = model('app\common\model\Progress');

        // $tree = Tree::instance();
        // $tree->init(collection($this->model->order('weigh desc,id desc')->select())->toArray(), 'pid');
        // $this->Progresslist = $tree->getTreeList($tree->getTreeArray(0), 'name');
        // $Progressdata = [0 => ['type' => 'all', 'name' => __('None')]];
        // foreach ($this->Progresslist as $k => $v) {
        //     $Progressdata[$v['id']] = $v;
        // }
        // $typeList = ProgressModel::getTypeList();
        // $this->view->assign("flagList", $this->model->getFlagList());
        // $this->view->assign("typeList", $typeList);
        // // $this->view->assign("parentList", $Progressdata);
        // $this->assignconfig('typeList', $typeList);
    // }

    /**
     * 查看
     */
    public function index()
    {
        //设置过滤方法
        $this->request->filter(['strip_tags']);
        if ($this->request->isAjax()) {
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }

            $offset = $this->request->request('offset');
            $limit = $this->request->request('limit');
            // var_dump($offset,$limit);die;

            $field = ['id','updatetime','sort','tlexplain','lctitle','lcimg','FROM_UNIXTIME(addtime,"%Y-%m-%d %H-%m %s") as addtime', 'FROM_UNIXTIME(lctime,"%Y-%m-%d %H-%m %s") as lctime'];
            $list =  Db::name('progress')->field($field)->order('sort desc')->limit($offset,$limit )->select();
            $result['total'] = Db::name('progress')->count();
            $result['rows'] = $list;
            return json($result);
         }
         return $this->view->fetch();
    }



    /**
     * 添加
     */
    public function add()
    {
        if ($this->request->isPost()) {
            $this->token();

            $rowItem = [];

            $rowItem['lctime'] = $this->request->request('row.lctime');
            $rowItem['lcimg'] = $this->request->request('row.lcimg');
            $rowItem['lctitle']=$this->request->request('row.lctitle');
            $rowItem['tlexplain'] = $this->request->request('row.tlexplain');
            $rowItem['addtime'] = time();
            $rowItem['updatetime'] = time();

            
            $rowItem['sort'] = $this->request->request('row.sort');
            
            
            if($rowItem["lctime"] == ""){
                return ['code' => -1,'data'=>[],'msg' => '历程时间'];
            }
            if($rowItem["lcimg"] == ""){
                return ['code' => -3,'data'=>[],'msg' => '历程图片'];
            }
            if($rowItem["lctitle"] == ""){
                return ['code' => -4,'data'=>[],'msg' => '历程标题'];
            }

            if($rowItem["tlexplain"] == ""){
                return ['code' => -4,'data'=>[],'msg' => '历程描述'];
            }

            
            $rowItem['lctime']  = strtotime($rowItem['lctime']);
            
            try {
                $res = Db::name('progress')->insert($rowItem);
                if($res>0){
                    return ['code' => 1,'data'=>[],'msg' => '添加成功'];
                }else{
                    return ['code' => 0,'data'=>[],'msg' => '添加失败'];
                }
            } catch (Exception $e) {
                return ['code' => -5,'data'=>[],'msg' => '错误异常.'];
            }
        }

        return parent::add();
    }

    /**
     * 编辑
     */
    public function edit($ids = null)
    {   
        $need_field = ['id','updatetime','sort','tlexplain','lctitle','lcimg','FROM_UNIXTIME(addtime,"%Y-%m-%d %H-%m %s") as addtime', 'FROM_UNIXTIME(lctime,"%Y-%m-%d %H-%m %s") as lctime'];
        $row =  Db::name('progress')->field($need_field)->where('id',$ids)->select();
        if ($this->request->isPost()) {
            // var_dump("测试111");die;
            $this->token();

            $rowItem = [];

            $rowItem['lctime'] = $this->request->request('row.lctime');
            $rowItem['lcimg'] = $this->request->request('row.lcimg');
            $rowItem['lctitle']=$this->request->request('row.lctitle');
            $rowItem['tlexplain'] = $this->request->request('row.tlexplain');
            $rowItem['addtime'] = time();
            $rowItem['updatetime'] = time();

            
            $rowItem['sort'] = $this->request->request('row.sort');
            
            
            if($rowItem["lctime"] == ""){
                return ['code' => -1,'data'=>[],'msg' => '历程时间'];
            }
            if($rowItem["lcimg"] == ""){
                return ['code' => -3,'data'=>[],'msg' => '历程图片'];
            }
            if($rowItem["lctitle"] == ""){
                return ['code' => -4,'data'=>[],'msg' => '历程标题'];
            }

            if($rowItem["tlexplain"] == ""){
                return ['code' => -4,'data'=>[],'msg' => '历程描述'];
            }

            $rowItem['lctime']  = strtotime($rowItem['lctime']);
            
            try {
                $res = Db::name('progress')->where('id', $ids)->update($rowItem);
                if($res>0){
                    return ['code' => 1,'data'=>[],'msg' => '修改成功'];
                }else{
                    return ['code' => 0,'data'=>[],'msg' => '添加失败'];
                }
            } catch (Exception $e) {
                return ['code' => -5,'data'=>[],'msg' => '错误异常.'];
            }
        }

        if(!$row){
            $row = [];
        }else{
            $row = $row[0];
        }
        $this->view->assign("row", $row);
        return $this->view->fetch();
    }

   
    /**
     * Selectpage搜索
     *
     * @internal
     */
    public function selectpage()
    {
        return parent::selectpage();
    }

    /***
     * 删除
     */
    public function del($ids=''){
        
        try {
            //code...
            $res = Db::name("progress")->delete($ids);
            if($res>0){
                return ['code' => 1,'data'=>[],'msg' => '操作成功.'];
            }else{
                return ['code' => -1,'data'=>[],'msg' => '操作失败'];
            }
        } catch (\Throwable $th) {
            //throw $th;
            return ['code' => -2,'data'=>[],'msg' => '错误请求'];
        }
        
        
    }
}
