<?php

namespace app\admin\controller;

use app\common\controller\Backend;
use app\common\model\Zizhi as ZizhiModel;
use fast\Tree;
use think\Db;

/**
 * 分类管理
 *
 * @icon   fa fa-list
 * @remark 用于管理网站的所有分类,分类可进行无限级分类,分类类型请在常规管理->系统配置->字典配置中添加
 */
class Zizhi extends Backend
{

    /**
     * @var \app\common\model\Zizhi
     */
    protected $model = null;
    protected $Zizhilist = [];
    protected $noNeedRight = ['selectpage'];

    // public function _initialize()
    // {
        // parent::_initialize();
        // $this->model = model('app\common\model\Zizhi');

        // $tree = Tree::instance();
        // $tree->init(collection($this->model->order('weigh desc,id desc')->select())->toArray(), 'pid');
        // $this->Zizhilist = $tree->getTreeList($tree->getTreeArray(0), 'name');
        // $Zizhidata = [0 => ['type' => 'all', 'name' => __('None')]];
        // foreach ($this->Zizhilist as $k => $v) {
        //     $Zizhidata[$v['id']] = $v;
        // }
        // $typeList = ZizhiModel::getTypeList();
        // $this->view->assign("flagList", $this->model->getFlagList());
        // $this->view->assign("typeList", $typeList);
        // // $this->view->assign("parentList", $Zizhidata);
        // $this->assignconfig('typeList', $typeList);
    // }

    /**
     * 查看
     */
    public function index()
    {
        //设置过滤方法
        $this->request->filter(['strip_tags']);
        if ($this->request->isAjax()) {
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }

            $offset = $this->request->request('offset');
            $limit = $this->request->request('limit');
            // var_dump($offset,$limit);die;

            $field = ['id','zz_img','sort','zz_title','zz_describe','zz_type','FROM_UNIXTIME(add_time,"%Y-%m-%d %H-%m %s") as add_time'];
            $list =  Db::name('Zizhi')->field($field)->order('sort desc,id desc')->limit($offset,$limit )->select();
            $result['total'] = Db::name('Zizhi')->count();
            $result['rows'] = $list;
            return json($result);
         }
         return $this->view->fetch();
    }



    /**
     * 添加
     */
    public function add()
    {
        if ($this->request->isPost()) {
            $this->token();

            $rowItem = [];

            $rowItem['zz_img'] = $this->request->request('row.zz_img');
            $rowItem['zz_title'] = $this->request->request('row.zz_title');
            $rowItem['zz_describe']=$this->request->request('row.zz_describe');
            $rowItem['zz_type'] = $this->request->request('row.zz_type');
            $rowItem['add_time'] = time();
            $rowItem['sort'] = $this->request->request('row.sort');
            
            
            if($rowItem["zz_img"] == ""){
                return ['code' => -1,'data'=>[],'msg' => '资质图片不能为空'];
            }
            if($rowItem["zz_title"] == ""){
                return ['code' => -3,'data'=>[],'msg' => '资质名称不能为空'];
            }
            if($rowItem["zz_type"] == ""){
                return ['code' => -4,'data'=>[],'msg' => '资质类型不能为空'];
            }

            try {
                $res = Db::name('Zizhi')->insert($rowItem);
                if($res>0){
                    return ['code' => 1,'data'=>[],'msg' => '添加成功'];
                }else{
                    return ['code' => 0,'data'=>[],'msg' => '添加失败'];
                }
            } catch (Exception $e) {
                return ['code' => -5,'data'=>[],'msg' => '错误异常.'];
            }
        }

        return parent::add();
    }

    /**
     * 编辑
     */
    public function edit($ids = null)
    {   
        $need_field = ['id','zz_img','sort','zz_title','zz_describe','zz_type','FROM_UNIXTIME(add_time,"%Y-%m-%d %H-%m %s") as add_time'];
        $row =  Db::name('Zizhi')->field($need_field)->where('id',$ids)->select();
        if ($this->request->isPost()) {
            // var_dump("测试111");die;
            $this->token();

            $rowItem = [];

            $rowItem['zz_img'] = $this->request->request('row.zz_img');
            $rowItem['zz_title'] = $this->request->request('row.zz_title');
            $rowItem['zz_describe']=$this->request->request('row.zz_describe');
            $rowItem['zz_type'] = $this->request->request('row.zz_type');
            $rowItem['add_time'] = time();
            $rowItem['sort'] = $this->request->request('row.sort');

            if($rowItem["zz_img"] == ""){
                return ['code' => -1,'data'=>[],'msg' => '资质图片不能为空'];
            }
            if($rowItem["zz_title"] == ""){
                return ['code' => -3,'data'=>[],'msg' => '资质名称不能为空'];
            }
            if($rowItem["zz_type"] == ""){
                return ['code' => -4,'data'=>[],'msg' => '资质类型不能为空'];
            }

            try {
                $res = Db::name('Zizhi')->where('id', $ids)->update($rowItem);
                if($res>0){
                    return ['code' => 1,'data'=>[],'msg' => '修改成功'];
                }else{
                    return ['code' => 0,'data'=>[],'msg' => '添加失败'];
                }
            } catch (Exception $e) {
                return ['code' => -5,'data'=>[],'msg' => '错误异常.'];
            }
        }

        if(!$row){
            $row = [];
        }else{
            $row = $row[0];
        }
        $this->view->assign("row", $row);
        return $this->view->fetch();
    }

   
    /**
     * Selectpage搜索
     *
     * @internal
     */
    public function selectpage()
    {
        return parent::selectpage();
    }

    /***
     * 删除
     */
    public function del($ids=''){
        
        try {
            //code...
            $res = Db::name("Zizhi")->delete($ids);
            if($res>0){
                return ['code' => 1,'data'=>[],'msg' => '操作成功.'];
            }else{
                return ['code' => -1,'data'=>[],'msg' => '操作失败'];
            }
        } catch (\Throwable $th) {
            //throw $th;
            return ['code' => -2,'data'=>[],'msg' => '错误请求'];
        }
        
        
    }

    //类型下拉框
    public function getsellect(){
        $selectdata = [
            "total"=> 2,
            "list"=>[
                [
                    "id"=> "1",
                    "name"=> "荣誉资质",
                ],
                [
                    "id"=> "2",
                    "name"=> "软著资质",
                ]
            ]
        ];

        return $selectdata;
        // return ['code' => -2,'data'=>[],'msg' => '错误请求'];
    }
}
